# -*- coding: iso-8859-15 -*-
##
##    Copyright (C) 2005 manatlan manatlan[at]gmail(dot)com
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 2 only.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
"""
====================================================================
smartpy
====================================================================
   moteur de template " la smarty" *lite*
   volutif au niveau de ses plugins (block/function/modifier)

implmente :
   block foreach
   block if/else
   block capture

   function include

   modifiers & variables

!BUG! parcours de liste qui contient des liste ;-(

12/01/05 - correction des item=$v (marchait pas avant ?!)
         - et ajouts de tests
         - ajout de __str__ sur Template (idem que .fetch())
         - ajout de __setitem__ sur Template (idem que .assign())
         - possibilit de rajouter des comments avec {* gfdsgf *} dans un tpl
         - imbrication de block fonctionne maintenant
         - amlioration objets
         - plus de prob de var dclar globalement dans les blocks

23/11/04 - Template sait lire un file now
====================================================================

"""
import re
import os

class PlugIns:
# """""""""""""""""""""""""""""""""""""""""""""""""""
   def __init__(self,tpl):
      self.__tpl=tpl

   def block_foreach(self,p,block):
      """
         {foreach from=$data item=v [key=k] }
            ...
         {/foreach}
      """
      b=""
      for k,v in enumerate( p["from"] ):
         di = { p["item"]: v}
         if "key" in p: di[ p["key"] ] = str(k+1)
         b+=self.__tpl._sub( di, block)
      return b


   def block_if(self,p,block):
      """
       {if test=$val egal="yes"}
         ...
       [ {else/} ]
         ...
       {/if}
      """
      if "{else/}" in block:
         good,bad = block.split("{else/}")
      else:
         good = block
         bad = ""

      if "egal" in p:
          if p["test"] == p["egal"]:
             return good
          else:
             return bad
      else:
          if p["test"]:
             return good
          else:
             return bad

   def block_capture(self,p,block):
      """
      {capture name="nom"}
         ...
      {/capture}
      """
      capt = self.__tpl._sub({}, block)
      self.__tpl.assign( p["name"],capt)
      return ""


   def function_include(self,p):
      """
      {include file="fds.ptp" [v=k ...] /}
      """
      b = open(p["file"],"rb").read()
      del(p["file"])
      return self.__tpl._sub(p,b)



class Template:
# """""""""""""""""""""""""""""""""""""""""""""""""""
   plug = PlugIns #plugins par defaut

   def __init__(self,buf):
        if os.path.isfile(buf):
            buf = open(buf,"r").read()
        self.__buf = buf
        self.__data = {}
        self.__log="LOG"+("-"*70)+"\n"
        self.__plugin = Template.plug(self)

   def assign(self,var,val):
      self.__data[var]=val

   def __setitem__(self,var,val): # new
       self.assign(var,val)

   def fetch(self):
      b=self.__buf
      b = self.__subComment(b)
      b = self.__subFunction(b)
      b = self.__subBlock(b)
      b = self.__subData(self.__data,b)
      return b

   def __str__(self): # NEW
       return self.fetch()

   def md5(self):
       return str(self.__data)

   def getPlugIn(self,type,mod):
        try:
            return getattr(self.__plugin, type+"_"+mod)
        except AttributeError:
            self.log("PLUGIN ERROR %s_%s()"%(type,mod))
            print "---","PLUGIN ERROR %s_%s()"%(type,mod)
            return None

   def log(self,l=None):
        if l:
            self.__log += l+"\n"
        else:
            return self.__log

   def __subFunction(self,b):
      #~ expr = re.compile( r'\{(\w+) (.*)\/\}',re.IGNORECASE )
      expr = re.compile( r'\{(\w+) ([^\}]*)\/\}',re.IGNORECASE )
      while 1:
         g = expr.search( b )
         if g:
            block = g.group(0)
            command = g.group(1)
            args =  g.group(2)
            params = self.__args2dict( args )
            self.log( "Function: %s(%s)\n  %s" % (command,args,params) )

            # appel de la "function"
            callback = self.getPlugIn("function",command)
            if callback:
                # replacement de la function
                b = b.replace( block, callback( params ) )
         else:
            break
      return b


   def __subComment(self,b): # nik les comments de suite ...
        b=b.replace("{*","{")
        b=b.replace("*}","}")

        expr = re.compile( r'(\{[^]*\})',re.IGNORECASE | re.MULTILINE | re.DOTALL)
        return expr.sub("",b)

   def __subBlock(self,b):
      expr = re.compile( r'\{(\w+) ?[^\}]*\}.*\{/\1\}',re.IGNORECASE | re.MULTILINE | re.DOTALL)

      while 1:
         g = expr.search( b )
         if g:
            command = g.group(1)
            self.log( "Traitement block : %s" % command )

            #subsitue la command par un carac spcial 

            # replace et "balise sans param" et les "balises de fermeture"
            b = re.sub( r"\{(/?)"+command+r"\}",r"{\1}",b)
            # replace la "balise avec param"
            b = re.sub( r"\{"+command+r"( +[^\}]*)\}",r"{\1}",b)

            expr2 = re.compile( r'\{ ?([^\}]*)\}([^]*)\{/}',re.IGNORECASE | re.MULTILINE | re.DOTALL)
            while 1:
               g = expr2.search( b )
               if g:
                  block = g.group(0)
                  args =  g.group(1)
                  content = g.group(2)
                  #~ content=content.strip(" \r\n\t")
                  params = self.__args2dict( args )
                  self.log( "Block:    %s(%s)\n  %s\n---\n%s\n---" % (command,args,params,content) )

                  # appel du "block"
                  callback = self.getPlugIn("block",command)
                  if callback:
                      #remplacement du block
                      b = b.replace( block, callback(params,content) )
               else:
                  break
         else:
            break

      return b


   def __args2dict(self,args ):
      #print "[%s]\n" % args

      # remplace les ",' par un unik carac : 
      args = re.sub("""['"]""","",args)

      d={}
      # trouve les [var=$var[|m|m..]]
      ln = re.findall(r'\w+ *= *\$\w+[\.\w]*[|\w]*', args )
      for i in ln:
         p = i.index("=")
         var = i[:p].strip()
         val = i[p+1:].strip()
         d[var]=self.__getVal(self.__data,val[1:])

      # trouve les [var="val"]
      ln = re.findall(r'\w+ *= *[^]*', args )
      for i in ln:
         p = i.index("=")
         var = i[:p].strip()
         val = i[p+1:].strip()
         d[var]=val[1:-1] # eneleve les guillemets

      # trouve les [var=var]
      ln = re.findall(r'\w+ *= *\w+', args )
      for i in ln:
         p = i.index("=")
         var = i[:p].strip()
         val = i[p+1:].strip()
         d[var]=val

      return d

   def _sub(self,d,b):
      """ fetch the template "b" with own data + "d" -> string """
      t = Template(b)
      t.__data = {}
      t.__data.update(self.__data)      # merge dict
      t.__data.update(d)      # merge dict
      return str(t)


   def __subData(self,d,b):
      expr = re.compile( '\{\$(\w+[\.\w]*[|\w]*)\}',re.IGNORECASE)

      ln = expr.findall( b )
      for i in ln:
         var,val = (i, self.__getVal(d,i) )
         self.log( "Data:     {$%s} = '%s'" %  (var,val) )
         b= b.replace("{$%s}" % var, str(val) )
      return b

   def __getVal(self,d,v):
      if "|" in v:
         # y a du modifier dedans
         p = v.index("|")
         # on rcupre la liste des modifiers appliqus
         mods = v[p+1:].split("|")

         # on va chercher la valeur $xxx
         val = self.__get(d,v[:p])

         # et on la passe dans les modifiers
         for mod in mods:
            callback = self.getPlugIn("modifier",mod)
            if callback:
                val = callback( val )

         return val
      else:
         #y a pas de modifier
         return self.__get(d,v)




   def __get(self,d,v):
      if "." in v:
         p = v.index(".")
         if v[:p] in d:
            return self.__get( d[ v[:p] ],v[p+1:]  )
         else:
            return "{$%s}" % v # si connait pas : renvoi le {$v}
      else:
         if v in d:
            return d[v]
         else:
            return "{$%s}" % v # si connait pas : renvoi le {$v}

